/*-----.par file reader-------*/
/*  (c)  rfs - 7/24/06        */

show_line "CDAT_Disp.S - CDAT File Display"
show_nl

init_var NMAX 10000
init_var Write_file = true

#---prompt for CDAT file name---

$dat_in = s.00.par
show_field "CDAT file name"
input0 $dat_in 

#---name the reformatted file---

show_nl
$dat_out = $dat_in
set_file_type $dat_out txt
show_field "    Output file name"
input0 $dat_out

write_line $dat_out "FILE = " $dat_in \n
if err  Write_file = false

#---read CDAT file--

read_line $dat_in $header
if err  exit
show $header
read_line $dat_in N M    // rows/columns
N = abs(N)
if N=0;  exit "Zero points in table";  end_if
if N=1
    show_line "   N=1....read to EOF"
    N = NMAX
end_if

if ~(N=NMAX)
  show_line "--> " @N " points in table"
  if Write_file  write_line $dat_out  "--> " @N " points in table"
end_if
show_line "--> " @abs(M) " fields per point"
if Write_file  write_line $dat_out  "--> " @abs(M) " fields per point" \n

show_nl

#---display/write param info---
if M<0
  M = -M
  read_line $dat_in Params
  show_line "--> " @Params " parameters found"
  if Write_file  write_line $dat_out ...Params...
  for_i = 1 Params       // read params, if any
    read_line $dat_in $plab[i]
    read_line $dat_in $Par[i]
    show_line $plab[i] " = " $Par[i]
    if Write_file  write_line $dat_out $plab[i] " = " $Par[i]
  end_i
else
  Params = 0
end_if

#---read labels---
for_i = 1 M
  read_line $data_file $Tmp
  str_sub $Tmp " "
  $Label[i] = $S_head
end_i

Nskip = 1
if N>10
  Nskip = int(N/10)
end_if

for_i = 1 N
                       // read data
  for_j = 1 M
    read_line $dat_in $X[j]
    if eof
      N = i-1
      goto out:
    end_if
  end_j
                       //  write data, transpose format
  if ~((i-1)%Nskip)
    write_line $dat_out
    show_nl
    if i=1
      if Write_file  write_line $dat_out ...Data...
    end_if
    for_j = 1 M
      if Write_file  write_line $dat_out $Label[j] " = " $X[j]
      show_line $Label[j] " = " $X[j]
    end_j
  end_if
end_i

out:

show_line \n "File " $dat_out " written   Records read = " @(i-1)
if Write_file  write_line $dat_out  \n "Records read = " @(i-1)
close_file $dat_out



