/*---Convert.s - Calculator and Unit Conversion Tool---*/
/*  Copyright (c) - Stellingwerf Consulting - 2005     */
/*  calculator version  4/25/2005 */
/*  precision added 6/7/2005  */
/*  Exp values added 7/26/05  */
/*  Exp fixed, changed to Val 11/4/05  */

show_line "----S-Calculator and Conversion Tool----"
show_nl

Val2 = 0
Val = 0
Tmp$ = 0
Exp = 0
Compute = false
$str1p = ""

Ver0 = 1.48           // version needed
if ver<Ver0
  show_line "Need translator version " @Ver0 " or better"
  show_line "...current version = " @ver
  exit
end_if 

#---put all units in this file---
read_file "units.inp"

show_nl
show_line " +==================================================+"
show_line " | Type u=list of units, p=change precision, q=quit |"
show_line " | previous values are  Val, Val2                   |"
show_line " +==================================================+"

noexit   //  new for version 1.48 - continue after error

for_i = 1 100
  show_nl
  if ~Compute
    $str1 = $str1p
  end_if

  #---main prompt---
  show_field "->Expression (with units)"
  input0 $str1

  #---quit---
  str_eq $str1 q
  if qq; exit; end_if

  #---precision---
  str_eq $str1 p
  if qq
    show_field "...Decimals(=" @dec ")(<0 for exp)"
    input0 Prec
    decimals Prec
    $str1 = ""
    Compute = false
    continue
  end_if

  #---display units file---
  str_eq $str1 u
  if qq
    system "Notepad \home\sdat\units.inp"
    $str1 = ""
    Compute = false
    continue 
  end_if

  #---prompt for optional units scaling---
  show_field "->Final units desired.."
  input0 $str2

  #---special cases---
  str_eq $str1 ""
  if qq; $str1 = 1; end_if
  str_eq $str2 ""
  if qq; $str2 = 1; end_if

  str_eq $str1 " "
  if qq; $str1 = 1; end_if
  str_eq $str2 " "
  if qq; $str2 = 1; end_if

  #---check for units---
  str_eq $str2 1
  Units = qq

  #---compute result, put in Exp---
  show_nl
  $str1p = $str1
  $expr = "Exp = (" + $str1 + ")/(" + $str2 + ")"
  exec $expr
  $expr = "Val = " + $str1 
  exec $expr

  #---error - skip final display---
  continue_if err

  #---display final result---
  if Units; show_line $str1  " = " @Exp 
  else;  show_line $str1  " = " @Exp "*" $str2
  end_if

  #---set previous values---
  Val2 = Tmp$
  Tmp$ = Val
end_i
