#---EXTREMUM--- 
#  test case at top of file
#  call update_X_g to use

show_line "Extremum" \n "F(x) = sin(x) test case, guess = 1.5" \n

function Fs(X$) = sin(X$)

X_g = 1.5     //  Guess

for_i = 1 100
  F_g = Fs(X_g)
  call update_X_g:
  show i X_g F_g
  break_if Converge_g
end_i

end


#------------iterate on X_g to find max F_g------------------#
#   call with X_g and F_g (guess) defined
#      returns a new X_g likely to increase F_g
#   uses Golden Section search algorithm

update_X_g:

init_var X0_g
init_var Tol_g = 1.e-3	// convergence criterion
init_var Converge_g	// = true when done
init_var Gsearch		// = true when close
init_var Passes$
Passes$ = Passes$+1

#---start by finding the right search direction---

if Passes$=1
  X_g_1 = X_g
  F_g_1 = F_g
  Delta$ = abs(X0_g-X_g)/10
  X_g = X_g+Delta$
  return
end_if

if Passes$=2
  X_g_2 = X_g
  F_g_2 = F_g
  if F_g<F_g_1    // reverse
    Delta$ = -Delta$
    X_g_2 = X_g_1
    F_g_2 = F_g_1
    X_g_1 = X_g
    F_g_1 = F_g
  end_if
  X_g = X_g_2+Delta$
  return
end_if

#---step forward to find max---

if ~Gsearch
  X_g_3 = X_g
  F_g_3 = F_g

  if F_g<F_g_2   //  found a max, begin search
    Gsearch =  true
    show_line "   >>> Begin Golden Section Search  <<<"
  else
    X_g = X_g+Delta$
    X_g = min(X_g,X0_g)
    X_g_1 = X_g_2
    F_g_1 = F_g_2
    X_g_2 = X_g_3
    F_g_2 = F_g_3
    return
  end_if
else            // Golden Section Case
  if F_g>F_g_2
    if Right_sect
      X_g_1 = X_g_2
      F_g_1 = F_g_2
      X_g_2 = X_g
      F_g_2 = F_g
    else
      X_g_3 = X_g_2
      F_g_3 = F_g_2
      X_g_2 = X_g
      F_g_2 = F_g
    end_if
  else
    if Right_sect
      X_g_3 = X_g
      F_g_3 = F_g
    else
      X_g_1 = X_g
      F_g_1 = F_g
     end_if
  end_if
end_if

#---Golden Section Search---
#  got x1, x2, x3, where x2 is a local max

if (X_g_3-X_g_2)>(X_g_2-X_g_1)
  X_g = X_g_2+0.382*(X_g_3-X_g_2)
  Right_sect = true
else
  X_g = X_g_2-0.382*(X_g_2-X_g_1)
  Right_sect = false
end_if

if ~X_g|abs((X_g-X_g_2)/X_g)<Tol_g
   Converge_g = true
end_if

return

     
        