/*---Program Input Example--------------
  Copyright Stellingwerf Consulting 2004
---------------------------------------*/

#--- this version has auto-indent---

#---indent commands---
Nind = 4
$ind[1] = if
$ind[2] = begin
$ind[3] = for
$ind[4] = do

#---exdent commands---
Nexd = 1
$exd[1] = end

#---set initial indent level---
Ind = 0

#---input a program---
show_line "Type program lines, do not indent, end with end"
show_nl
for_i = 1 200
  show_field "   " @i ". "
  input0 $Line[i]
  $Line = $Line[i]
  call indent:
  $Line[i] = $Line
  if eof
    break;
  end_if
end_i
Lines = i-1

#---display the program---
show_nl
for_i = 1 Lines
  show $Line[i]
end_i

if Ind
  exit "Error: final indent level not zero!"
end_if

#--=set file for write---
show_nl
$File = "prog_test.s"
show_field "File name? " 
input0 $File

if eof
  show_line "file not written"
else
    write_line $File "#---Custom Program---"
  for_i = 1 Lines
    write_line $File $Line[i]
  end_i
  show_nl
  show_line "Program written to file " $File
  close_file $File
end_if

# execute program...

show_nl
show_line "Executing program..."
show_nl

// test of array exec - works, but no loops
//for_i = 1 Lines
//  exec $Line[i]
//end_i

// better way
read_file $File

end

#-------------------------------

#---indent program lines---

indent:

#---check for exdent---
for_i = 1 Nexd
  str_len $exd[i]
  str_eq $Line $exd[i]
  if S_eq=S_len
    Ind = Ind-1
    if Ind<0; exit "negative indent level"; end_if
    break
  end_if
end_i

#---apply current indent level---
$str = ""
if Ind
  for_i = 1 Ind
    $str = $str + "  "
  end_i
end_if
$Line$ = $Line
$str = $str + $Line
$Line = $str

#---check for indent---
for_i = 1 Nind
  str_len $ind[i]
  str_eq $Line$ $ind[i]
  if S_eq=S_len
    Ind = Ind+1
    break
  end_if
end_i
return
