#---SECANT---
#  Example at top of file
#  Call update_X_s to use

show_line "SECANT" \n "F(x) = sin(x) test case, guess = 3" \n

function Fs(X$) = sin(X$)

X_s = 3.0     //  Guess

for_i = 1 100
  F_s = Fs(X_s)
  call update_X_s:
  show i X_s F_s
  break_if Converge_s
end_i

end

#--------find roots of a function----------------
#   call with X_s (guess) and F_s defined
#      returns a new X_s likely to decrease |F_s|
#   call again with F_s for the new X_s
#   test on Converge_s to see when done
#   uses Secant search algorithm

update_X_s:

init_var Tol_s = 1.e-6	// convergence criterion
init_var Uc_fact = 0.5  // undercorrect factor
init_var Converge_s	// = true when done
init_var Max_passes_s = 1000  //max iterations
init_var Noconverge = 0  //  set if no convergence

init_var Passes$
if Noconverge
  Passes$ = 0
  Noconverge = false
end_if
Passes$ = Passes$+1       // count iterations

#---no convergence test---
if Passes$>Max_passes_s
  exit "Secant: no convergence"
end_if

#---first pass setup---
if Passes$=1
  D_s = X_s/1000
  if D_s=0
    D_s = 1.e-3
  end_if
  C1$ = 1
  Converge_s = false
end_if

#---general setup---
F2_s = F_s
if F2_s=0
  Converge_s = true
  return
end_if
X1$ = X_s
if X1$=0
  X1$ = 1
end_if

#---compute after first pass---
if ~(Passes$=1)
  C2$ = F1_s-F2_s
  if C2$=0
    C2$ = Tol_s
  end_if
  D_s = D_s*F2_s/C2$
  C1$ = abs(D_s/X1$)
  if C1$>Uc_fact
    D_s = sign(D_s)*abs(X1$)*Uc_fact
  end_if
end_if

#---advance---
F1_s = F2_s
X_s = X_s+D_s

#---convergence test---
if C1$<Tol_s
  Converge_s = true
  Passes$ = 0
  return
end_if
return        